| OpenCV 4.3.0 Open Source Computer Vision

Public Member Functions | Static Public Member Functions | List of all members
cv::_InputOutputArray Class Reference
Core functionality » Basic structures

`#include <opencv2/core/mat.hpp>`

Inheritance diagram for cv::_InputOutputArray:

## Public Member Functions
| _InputOutputArray ()
| _InputOutputArray (int _flags, void *_obj)
| _InputOutputArray (Mat &m)
| _InputOutputArray (std::vector< Mat > &vec)
| _InputOutputArray (cuda::GpuMat &d_mat)
| _InputOutputArray (ogl::Buffer &buf)
| _InputOutputArray (cuda::HostMem &cuda_mem)
template<typename _Tp >
| _InputOutputArray (cudev::GpuMat_< _Tp > &m)
template<typename _Tp >
| _InputOutputArray (std::vector< _Tp > &vec)
| _InputOutputArray (std::vector< bool > &vec)=delete
template<typename _Tp >
| _InputOutputArray (std::vector< std::vector< _Tp > > &vec)
template<typename _Tp >
| _InputOutputArray (std::vector< Mat_< _Tp > > &vec)
template<typename _Tp >
| _InputOutputArray (Mat_< _Tp > &m)
template<typename _Tp >
| _InputOutputArray (_Tp *vec, int n)
template<typename _Tp , int m, int n>
| _InputOutputArray (Matx< _Tp, m, n > &matx)
| _InputOutputArray (UMat &m)
| _InputOutputArray (std::vector< UMat > &vec)
| _InputOutputArray (const Mat &m)
| _InputOutputArray (const std::vector< Mat > &vec)
| _InputOutputArray (const cuda::GpuMat &d_mat)
| _InputOutputArray (const std::vector< cuda::GpuMat > &d_mat)
| _InputOutputArray (const ogl::Buffer &buf)
| _InputOutputArray (const cuda::HostMem &cuda_mem)
template<typename _Tp >
| _InputOutputArray (const cudev::GpuMat_< _Tp > &m)
template<typename _Tp >
| _InputOutputArray (const std::vector< _Tp > &vec)
template<typename _Tp >
| _InputOutputArray (const std::vector< std::vector< _Tp > > &vec)
template<typename _Tp >
| _InputOutputArray (const std::vector< Mat_< _Tp > > &vec)
template<typename _Tp >
| _InputOutputArray (const Mat_< _Tp > &m)
template<typename _Tp >
| _InputOutputArray (const _Tp *vec, int n)
template<typename _Tp , int m, int n>
| _InputOutputArray (const Matx< _Tp, m, n > &matx)
| _InputOutputArray (const UMat &m)
| _InputOutputArray (const std::vector< UMat > &vec)
template<typename _Tp , std::size_t _Nm>
| _InputOutputArray (std::array< _Tp, _Nm > &arr)
template<typename _Tp , std::size_t _Nm>
| _InputOutputArray (const std::array< _Tp, _Nm > &arr)
template<std::size_t _Nm>
| _InputOutputArray (std::array< Mat, _Nm > &arr)
template<std::size_t _Nm>
| _InputOutputArray (const std::array< Mat, _Nm > &arr)
template<typename _Tp , std::size_t _Nm>
_InputOutputArray | rawInOut (std::array< _Tp, _Nm > &arr)
Public Member Functions inherited from cv::_OutputArray
| _OutputArray ()
| _OutputArray (int _flags, void *_obj)
| _OutputArray (Mat &m)
| _OutputArray (std::vector< Mat > &vec)
| _OutputArray (cuda::GpuMat &d_mat)
| _OutputArray (std::vector< cuda::GpuMat > &d_mat)
| _OutputArray (ogl::Buffer &buf)
| _OutputArray (cuda::HostMem &cuda_mem)
template<typename _Tp >
| _OutputArray (cudev::GpuMat_< _Tp > &m)
template<typename _Tp >
| _OutputArray (std::vector< _Tp > &vec)
| _OutputArray (std::vector< bool > &vec)=delete
template<typename _Tp >
| _OutputArray (std::vector< std::vector< _Tp > > &vec)
| _OutputArray (std::vector< std::vector< bool > > &)=delete
template<typename _Tp >
| _OutputArray (std::vector< Mat_< _Tp > > &vec)
template<typename _Tp >
| _OutputArray (Mat_< _Tp > &m)
template<typename _Tp >
| _OutputArray (_Tp *vec, int n)
template<typename _Tp , int m, int n>
| _OutputArray (Matx< _Tp, m, n > &matx)
| _OutputArray (UMat &m)
| _OutputArray (std::vector< UMat > &vec)
| _OutputArray (const Mat &m)
| _OutputArray (const std::vector< Mat > &vec)
| _OutputArray (const cuda::GpuMat &d_mat)
| _OutputArray (const std::vector< cuda::GpuMat > &d_mat)
| _OutputArray (const ogl::Buffer &buf)
| _OutputArray (const cuda::HostMem &cuda_mem)
template<typename _Tp >
| _OutputArray (const cudev::GpuMat_< _Tp > &m)
template<typename _Tp >
| _OutputArray (const std::vector< _Tp > &vec)
template<typename _Tp >
| _OutputArray (const std::vector< std::vector< _Tp > > &vec)
template<typename _Tp >
| _OutputArray (const std::vector< Mat_< _Tp > > &vec)
template<typename _Tp >
| _OutputArray (const Mat_< _Tp > &m)
template<typename _Tp >
| _OutputArray (const _Tp *vec, int n)
template<typename _Tp , int m, int n>
| _OutputArray (const Matx< _Tp, m, n > &matx)
| _OutputArray (const UMat &m)
| _OutputArray (const std::vector< UMat > &vec)
template<typename _Tp , std::size_t _Nm>
| _OutputArray (std::array< _Tp, _Nm > &arr)
template<typename _Tp , std::size_t _Nm>
| _OutputArray (const std::array< _Tp, _Nm > &arr)
template<std::size_t _Nm>
| _OutputArray (std::array< Mat, _Nm > &arr)
template<std::size_t _Nm>
| _OutputArray (const std::array< Mat, _Nm > &arr)
void | assign (const UMat &u) const
void | assign (const Mat &m) const
void | assign (const std::vector< UMat > &v) const
void | assign (const std::vector< Mat > &v) const
void | clear () const
void | create (Size sz, int type, int i=-1, bool allowTransposed=false, _OutputArray::DepthMask fixedDepthMask=static_cast< _OutputArray::DepthMask >(0)) const
void | create (int rows, int cols, int type, int i=-1, bool allowTransposed=false, _OutputArray::DepthMask fixedDepthMask=static_cast< _OutputArray::DepthMask >(0)) const
void | create (int dims, const int *size, int type, int i=-1, bool allowTransposed=false, _OutputArray::DepthMask fixedDepthMask=static_cast< _OutputArray::DepthMask >(0)) const
void | createSameSize (const _InputArray &arr, int mtype) const
bool | fixedSize () const
bool | fixedType () const
cuda::GpuMat & | getGpuMatRef () const
std::vector< cuda::GpuMat > & | getGpuMatVecRef () const
cuda::HostMem & | getHostMemRef () const
Mat & | getMatRef (int i=-1) const
ogl::Buffer & | getOGlBufferRef () const
UMat & | getUMatRef (int i=-1) const
void | move (UMat &u) const
void | move (Mat &m) const
bool | needed () const
void | release () const
void | setTo (const _InputArray &value, const _InputArray &mask=_InputArray()) const
Public Member Functions inherited from cv::_InputArray
| _InputArray ()
| _InputArray (int _flags, void *_obj)
| _InputArray (const Mat &m)
| _InputArray (const MatExpr &expr)
| _InputArray (const std::vector< Mat > &vec)
template<typename _Tp >
| _InputArray (const Mat_< _Tp > &m)
template<typename _Tp >
| _InputArray (const std::vector< _Tp > &vec)
| _InputArray (const std::vector< bool > &vec)
template<typename _Tp >
| _InputArray (const std::vector< std::vector< _Tp > > &vec)
| _InputArray (const std::vector< std::vector< bool > > &)=delete
template<typename _Tp >
| _InputArray (const std::vector< Mat_< _Tp > > &vec)
template<typename _Tp >
| _InputArray (const _Tp *vec, int n)
template<typename _Tp , int m, int n>
| _InputArray (const Matx< _Tp, m, n > &matx)
| _InputArray (const double &val)
| _InputArray (const cuda::GpuMat &d_mat)
| _InputArray (const std::vector< cuda::GpuMat > &d_mat_array)
| _InputArray (const ogl::Buffer &buf)
| _InputArray (const cuda::HostMem &cuda_mem)
template<typename _Tp >
| _InputArray (const cudev::GpuMat_< _Tp > &m)
| _InputArray (const UMat &um)
| _InputArray (const std::vector< UMat > &umv)
template<typename _Tp , std::size_t _Nm>
| _InputArray (const std::array< _Tp, _Nm > &arr)
template<std::size_t _Nm>
| _InputArray (const std::array< Mat, _Nm > &arr)
| ~_InputArray ()
int | channels (int i=-1) const
int | cols (int i=-1) const
void | copyTo (const _OutputArray &arr) const
void | copyTo (const _OutputArray &arr, const _InputArray &mask) const
int | depth (int i=-1) const
int | dims (int i=-1) const
bool | empty () const
int | getFlags () const
cuda::GpuMat | getGpuMat () const
void | getGpuMatVector (std::vector< cuda::GpuMat > &gpumv) const
Mat | getMat (int idx=-1) const
Mat | getMat_ (int idx=-1) const
void | getMatVector (std::vector< Mat > &mv) const
void * | getObj () const
ogl::Buffer | getOGlBuffer () const
Size | getSz () const
UMat | getUMat (int idx=-1) const
void | getUMatVector (std::vector< UMat > &umv) const
bool | isContinuous (int i=-1) const
bool | isGpuMat () const
bool | isGpuMatVector () const
bool | isMat () const
bool | isMatVector () const
bool | isMatx () const
bool | isSubmatrix (int i=-1) const
bool | isUMat () const
bool | isUMatVector () const
bool | isVector () const
_InputArray::KindFlag | kind () const
size_t | offset (int i=-1) const
int | rows (int i=-1) const
bool | sameSize (const _InputArray &arr) const
Size | size (int i=-1) const
int | sizend (int *sz, int i=-1) const
size_t | step (int i=-1) const
size_t | total (int i=-1) const
int | type (int i=-1) const

## Static Public Member Functions
template<typename _Tp >
static _InputOutputArray | rawInOut (std::vector< _Tp > &vec)
Static Public Member Functions inherited from cv::_OutputArray
template<typename _Tp >
static _OutputArray | rawOut (std::vector< _Tp > &vec)
template<typename _Tp , std::size_t _Nm>
static _OutputArray | rawOut (std::array< _Tp, _Nm > &arr)
Static Public Member Functions inherited from cv::_InputArray
template<typename _Tp >
static _InputArray | rawIn (const std::vector< _Tp > &vec)
template<typename _Tp , std::size_t _Nm>
static _InputArray | rawIn (const std::array< _Tp, _Nm > &arr)

## Additional Inherited Members
Public Types inherited from cv::_OutputArray
enum | DepthMask { DEPTH_MASK_8U = 1 << CV_8U, DEPTH_MASK_8S = 1 << CV_8S, DEPTH_MASK_16U = 1 << CV_16U, DEPTH_MASK_16S = 1 << CV_16S, DEPTH_MASK_32S = 1 << CV_32S, DEPTH_MASK_32F = 1 << CV_32F, DEPTH_MASK_64F = 1 << CV_64F, DEPTH_MASK_16F = 1 << CV_16F, DEPTH_MASK_ALL = (DEPTH_MASK_64F<<1)-1, DEPTH_MASK_ALL_BUT_8S = DEPTH_MASK_ALL & ~DEPTH_MASK_8S, DEPTH_MASK_ALL_16F = (DEPTH_MASK_16F<<1)-1, DEPTH_MASK_FLT = DEPTH_MASK_32F + DEPTH_MASK_64F }
Public Types inherited from cv::_InputArray
enum | KindFlag { KIND_SHIFT = 16, FIXED_TYPE = 0x8000 << KIND_SHIFT, FIXED_SIZE = 0x4000 << KIND_SHIFT, KIND_MASK = 31 << KIND_SHIFT, NONE = 0 << KIND_SHIFT, MAT = 1 << KIND_SHIFT, MATX = 2 << KIND_SHIFT, STD_VECTOR = 3 << KIND_SHIFT, STD_VECTOR_VECTOR = 4 << KIND_SHIFT, STD_VECTOR_MAT = 5 << KIND_SHIFT, EXPR = 6 << KIND_SHIFT, OPENGL_BUFFER = 7 << KIND_SHIFT, CUDA_HOST_MEM = 8 << KIND_SHIFT, CUDA_GPU_MAT = 9 << KIND_SHIFT, UMAT =10 << KIND_SHIFT, STD_VECTOR_UMAT =11 << KIND_SHIFT, STD_BOOL_VECTOR =12 << KIND_SHIFT, STD_VECTOR_CUDA_GPU_MAT = 13 << KIND_SHIFT, STD_ARRAY =14 << KIND_SHIFT, STD_ARRAY_MAT =15 << KIND_SHIFT }
Protected Member Functions inherited from cv::_InputArray
void | init (int _flags, const void *_obj)
void | init (int _flags, const void *_obj, Size _sz)
Protected Attributes inherited from cv::_InputArray
int | flags
void * | obj
Size | sz

## Constructor & Destructor Documentation

## ◆ _InputOutputArray() [1/36]

cv::_InputOutputArray::_InputOutputArray | ( |  | ) |

## ◆ _InputOutputArray() [2/36]

cv::_InputOutputArray::_InputOutputArray | ( | int | _flags,
|  | void * | _obj
| ) |  |

## ◆ _InputOutputArray() [3/36]

cv::_InputOutputArray::_InputOutputArray | ( | Mat & | m | ) |

## ◆ _InputOutputArray() [4/36]

cv::_InputOutputArray::_InputOutputArray | ( | std::vector< Mat > & | vec | ) |

## ◆ _InputOutputArray() [5/36]

cv::_InputOutputArray::_InputOutputArray | ( | cuda::GpuMat & | d_mat | ) |

## ◆ _InputOutputArray() [6/36]

cv::_InputOutputArray::_InputOutputArray | ( | ogl::Buffer & | buf | ) |

## ◆ _InputOutputArray() [7/36]

cv::_InputOutputArray::_InputOutputArray | ( | cuda::HostMem & | cuda_mem | ) |

## ◆ _InputOutputArray() [8/36]

template<typename _Tp >

cv::_InputOutputArray::_InputOutputArray | ( | cudev::GpuMat_< _Tp > & | m | ) |

## ◆ _InputOutputArray() [9/36]

template<typename _Tp >

cv::_InputOutputArray::_InputOutputArray | ( | std::vector< _Tp > & | vec | ) |

## ◆ _InputOutputArray() [10/36]

cv::_InputOutputArray::_InputOutputArray | ( | std::vector< bool > & | vec | ) |
| delete

## ◆ _InputOutputArray() [11/36]

template<typename _Tp >

cv::_InputOutputArray::_InputOutputArray | ( | std::vector< std::vector< _Tp > > & | vec | ) |

## ◆ _InputOutputArray() [12/36]

template<typename _Tp >

cv::_InputOutputArray::_InputOutputArray | ( | std::vector< Mat_< _Tp > > & | vec | ) |

## ◆ _InputOutputArray() [13/36]

template<typename _Tp >

cv::_InputOutputArray::_InputOutputArray | ( | Mat_< _Tp > & | m | ) |

## ◆ _InputOutputArray() [14/36]

template<typename _Tp >

cv::_InputOutputArray::_InputOutputArray | ( | _Tp * | vec,
|  | int | n
| ) |  |

## ◆ _InputOutputArray() [15/36]

template<typename _Tp , int m, int n>

cv::_InputOutputArray::_InputOutputArray | ( | Matx< _Tp, m, n > & | matx | ) |

## ◆ _InputOutputArray() [16/36]

cv::_InputOutputArray::_InputOutputArray | ( | UMat & | m | ) |

## ◆ _InputOutputArray() [17/36]

cv::_InputOutputArray::_InputOutputArray | ( | std::vector< UMat > & | vec | ) |

## ◆ _InputOutputArray() [18/36]

cv::_InputOutputArray::_InputOutputArray | ( | const Mat & | m | ) |

## ◆ _InputOutputArray() [19/36]

cv::_InputOutputArray::_InputOutputArray | ( | const std::vector< Mat > & | vec | ) |

## ◆ _InputOutputArray() [20/36]

cv::_InputOutputArray::_InputOutputArray | ( | const cuda::GpuMat & | d_mat | ) |

## ◆ _InputOutputArray() [21/36]

cv::_InputOutputArray::_InputOutputArray | ( | const std::vector< cuda::GpuMat > & | d_mat | ) |

## ◆ _InputOutputArray() [22/36]

cv::_InputOutputArray::_InputOutputArray | ( | const ogl::Buffer & | buf | ) |

## ◆ _InputOutputArray() [23/36]

cv::_InputOutputArray::_InputOutputArray | ( | const cuda::HostMem & | cuda_mem | ) |

## ◆ _InputOutputArray() [24/36]

template<typename _Tp >

cv::_InputOutputArray::_InputOutputArray | ( | const cudev::GpuMat_< _Tp > & | m | ) |

## ◆ _InputOutputArray() [25/36]

template<typename _Tp >

cv::_InputOutputArray::_InputOutputArray | ( | const std::vector< _Tp > & | vec | ) |

## ◆ _InputOutputArray() [26/36]

template<typename _Tp >

cv::_InputOutputArray::_InputOutputArray | ( | const std::vector< std::vector< _Tp > > & | vec | ) |

## ◆ _InputOutputArray() [27/36]

template<typename _Tp >

cv::_InputOutputArray::_InputOutputArray | ( | const std::vector< Mat_< _Tp > > & | vec | ) |

## ◆ _InputOutputArray() [28/36]

template<typename _Tp >

cv::_InputOutputArray::_InputOutputArray | ( | const Mat_< _Tp > & | m | ) |

## ◆ _InputOutputArray() [29/36]

template<typename _Tp >

cv::_InputOutputArray::_InputOutputArray | ( | const _Tp * | vec,
|  | int | n
| ) |  |

## ◆ _InputOutputArray() [30/36]

template<typename _Tp , int m, int n>

cv::_InputOutputArray::_InputOutputArray | ( | const Matx< _Tp, m, n > & | matx | ) |

## ◆ _InputOutputArray() [31/36]

cv::_InputOutputArray::_InputOutputArray | ( | const UMat & | m | ) |

## ◆ _InputOutputArray() [32/36]

cv::_InputOutputArray::_InputOutputArray | ( | const std::vector< UMat > & | vec | ) |

## ◆ _InputOutputArray() [33/36]

template<typename _Tp , std::size_t _Nm>

cv::_InputOutputArray::_InputOutputArray | ( | std::array< _Tp, _Nm > & | arr | ) |

## ◆ _InputOutputArray() [34/36]

template<typename _Tp , std::size_t _Nm>

cv::_InputOutputArray::_InputOutputArray | ( | const std::array< _Tp, _Nm > & | arr | ) |

## ◆ _InputOutputArray() [35/36]

template<std::size_t _Nm>

cv::_InputOutputArray::_InputOutputArray | ( | std::array< Mat, _Nm > & | arr | ) |

## ◆ _InputOutputArray() [36/36]

template<std::size_t _Nm>

cv::_InputOutputArray::_InputOutputArray | ( | const std::array< Mat, _Nm > & | arr | ) |

## Member Function Documentation

## ◆ rawInOut() [1/2]

template<typename _Tp >

static _InputOutputArray cv::_InputOutputArray::rawInOut | ( | std::vector< _Tp > & | vec | ) |
| static

## ◆ rawInOut() [2/2]

template<typename _Tp , std::size_t _Nm>

_InputOutputArray cv::_InputOutputArray::rawInOut | ( | std::array< _Tp, _Nm > & | arr | ) |

The documentation for this class was generated from the following file:

- opencv2/core/mat.hpp